# This function uses the bisection algorithm to find the roots of an
# equation.  It is intended for educational purposes, as there are
# faster methods available for general use.   

# Author: Kevin Straight, stra9456@uidaho.edu
# License: GPL

function retval = bisection (eq, a, b, Tol, MaxIterations)

  if (nargin < 5) 
    MaxIterations = 100;
  endif

  if (nargin < 4) 
    Tol = 1e-8;
  endif

  eq = strcat(eq, ";");

  pstar = b;
  p = (a+b)/2;
  i = 1;

  printf("\nIteration\ta_n\t\tb_n\t\tp_n\t\tf(p_n)\n");
  printf("---------\t---\t\t---\t\t---\t\t------\n");

  while( ((abs(p-pstar)/p) > Tol) & (i<=MaxIterations) )
     
     eval_eq(eq, "x", a);
     Fa = ans;
     eval_eq(eq, "x", p);
     Fp = ans;

     printf("%g\t\t%f\t%f\t%f\t%f\n", i, a, b, p, Fp);
     
     if((Fa*Fp) < 0)
       b=p;
     endif

     if((Fa*Fp) > 0)
       a=p;
     endif

     pstar=p;
     p=(a+b)/2;
     i++;
  endwhile

  retval = p;
endfunction
