## gd_segment  - Draws line segments
##
## This function is part of Goctave Draw, a set of drawing primitives 
## distributed with Goctave.
##
## Author: Kevin Straight, stra9456@uidaho.edu
## License: GPL

function retval = gd_segment(image, color, x0, y0, x1, y1)

     if (nargin < 6)
        usage ("image = gd_segment(image, color, x0, y0, x1, y1)");
     endif

     if (x0==x1)
       for y = min([y0, y1]):max([y0, y1])
	 image(y, x0) = color;
       endfor
     else

       if (y0 == y1)
	 for x = min([x0, x1]):max([x0, x1])
	   image(y0, x) = color;
	 endfor
       else
	 m = (y0-y1)/(x0-x1);
	 y = y0;
     
	 for x = x0:x1
	   for yi = min([y, y+m]):max([y, y+m])	 
	     image(yi,x) = color;
	   endfor
	   y = y + m;
	 endfor
       endif
     endif

     retval = image;

endfunction
