## usage: makecsv (matrix, filename)
##
## Stores a matrix in Data Interchange Format, for import
##     into a spreadsheet, database, etc.
##
## Author: Kevin Straight, stra9456@uidaho.edu

function retval = makecsv (m, filename)

  if (nargin != 2)
    usage ("makecsv (matrix, filename)");
  endif

  file=fopen(filename, "w");

  for i = 1:rows(m)
    for j = 1:columns(m)
      fputs(file, sprintf("%g", m(i,j)  ));
      if (j < columns(m))
	fputs(file, ", ");
      endif
    endfor
    fputs(file, "\n");
  endfor

  fclose(file);

  retval=m;

endfunction
