## usage: makedif (matrix, filename)
##
## Stores a matrix in Data Interchange Format, for import
##     into a spreadsheet, database, etc.
##
## Author: Kevin Straight, stra9456@uidaho.edu

function retval = makedif (m, filename)

  if (nargin != 2)
    usage ("makedif (matrix, filename)");
  endif

  file=fopen(filename, "w");
  fputs(file, "TABLE\n");
  fputs(file, "0,1\n");
  fputs(file, "\"OCTAVE\"\n");
  fputs(file, "VECTORS\n");
  fputs(file, "0,");
  fprintf(file, "%d", (rows(m)-1));
  fputs(file, "\n\"\"\nTUPLES\n0,");
  fprintf(file, "%d\n\"\"\nDATA\n0,0\n\"\"\n", (columns(m)-1));

  for i=1:columns(m)
    fputs(file, "-1,0\nBOT\n");
    for j=1:rows(m)
      fputs(file, "1,0\n");
      q=m(j,i);
      fprintf(file, "\"%f\"\n", q);
    endfor
  endfor

  fputs(file, "-1,0\nEOD\n");

  fclose(file);

  retval=m;

endfunction
