## maxima() - Octave/Maxima interconnectivey
##
## Executes a Maxima expression.  If called with no arguments, 
## envokes a Maxima command line.
##
## Author: Kevin Straight stra9456@uidaho.edu
## License:  GPL

function maxima(expression)

     if (nargin < 1)
       puts("\n");
       system("maxima");
     else
       if (!strcmp(expression(columns(expression)), ";"))
	 expression = strcat(expression, ";");
       endif

       mfd = popen("maxima | body 5 | grep -v \"(C\"", "w");
       fputs(mfd, expression);

       fputs(mfd, "quit();");
       fclose(mfd);
     endif

endfunction
