# This function uses the Newton Raphson method to find the roots for
# any equation for which you know the first derivitive. 

# Since, obviously, in real life you often don't know the dericitive,
# this is intended for educational purposes.

# Author: Kevin Straight, stra9456@uidaho.edu
# License: GPL

function retval = newton (eq, eq_prime, p_0, Tol, MaxIterations)

  if (nargin < 3)
     usage("retval = newton (f, f', p_0, [Tolerance,] [MaxIterations]\n");
  endif

  if (nargin < 5) 
    MaxIterations = 100;
  endif

  if (nargin < 4) 
    Tol = 1e-8;
  endif

  i = 1;

  p=p_0;
  eval_eq(strcat(eq, ";"), "x", p_0);
  pstar = ans;

  printf("\nIteration\tp_n\t\tg(p_n)\n");
  printf("---------\t---\t\t------\n");

  while( ((abs(p-pstar)/p) > Tol) & (i<=MaxIterations) )
    pstar = p;

    eval_eq(strcat("x - (", eq, ")/(",eq_prime, ");"), "x", p);
    p = ans;

    printf("%d\t\t%f\t%f\n", i, pstar, p);  

    i++;

  endwhile

  retval = p;
endfunction
