## usage: rref (m)
##
## Return the reduced-row-eschelon-form of matrix m.

## Author: Kevin Straight, stra9456@uidaho.edu

function retval = rref (m, dummy)

     if (nargin < 1)
        usage ("rref (x)");
     endif

#     m=sortrows(m);

# Bring the pivot to the top row

     for i=1:rows(m)
       if(m(i,1)==max(m(:,1)))
	 scratch=m(i,:);
	 m(i,:)=m(1,:);
	 m(1,:)=scratch;

       endif	 
     endfor

     if(m(1,1)!=0)
       m(1,:)=m(1,:)/m(1,1);

       for i=2:rows(m)

	 if(m(i,1)!=0)

	   m(i,:)=(m(i,:)/m(i,1))-m(1,:);

	 endif
       endfor
     else
	 if(any(m(1,:)))
	   q=2;
	   while(m(1,q)==0)
	     q++;
	   endwhile
	   m(1,:)=m(1,:)/m(1,q);
         endif
     endif

     if(columns(m)>1 && rows(m)>1)
	m(2:rows(m),2:columns(m)) = rref( m(2:rows(m),2:columns(m)),1 );		
     endif


# Swell, now we're row reduced.  Lets get to rref

     if((rows(m)>=2) && (columns(m) >=2) && (nargin ==1))

     for i=0:rows(m)-1
       if( any( m(rows(m)-i,:) ) )

	 q=1;
	 while(m(rows(m)-i,q)==0)
	   q++;
	 endwhile
	 for j=1:rows(m)-i-1
	   m(j,:)=m(j,:)-(m(rows(m)-i,:)*m(j,q));
	 endfor

       endif
     endfor

     endif

     retval = m;

endfunction
