# This uses the secant method to find a root to an equation, given 
# two "guesses".

# Author: Kevin Straight, stra9456@uidaho.edu
# License: GPL

function retval = secant (eq, p_0, p_1, Tol, MaxIterations)

  if (nargin < 3)
     usage("retval = newton (f, p_0, p_1, [Tolerance,] [MaxIterations]\n");
  endif

  if (nargin < 5) 
    MaxIterations = 100;
  endif

  if (nargin < 4) 
    Tol = 1e-8;
  endif

  i = 2;
  eval_eq(strcat(eq, ";"), "x", p_0);
  q_0 = ans;
  eval_eq(strcat(eq, ";"), "x", p_1);
  q_1 = ans;
  printf("Iteration\tp_n\tp_n+1\tp\n");
  printf("---------\t---\t-----\t-\n");

  p = p_0;

  while ((i < MaxIterations))
    p = p_1 - q_1*(p_1 - p_0)/(q_1 - q_0);

    if(abs(p-p_1) < Tol)
      break
    endif

    printf("%d\t\t%g\t%g\t%g\n", i-1, p_0, p_1, p);

    i++;

    p_0 = p_1;
    q_0 = q_1;
    p_1 = p;
    eval_eq(strcat(eq, ";"), "x", p);
    q_1 = ans;

  endwhile
  

  retval = p;
endfunction
