## usage: sortrows(m, c)
##
## Sorts the rows of matrix m left to right in descending
##     order.  Keeps each row together.
##
##
## Based heavily on public domain code by Daniel Calvelo

function s = sortrows( m,c ),
  if nargin<2,
    indices = [1:size(m,2)]';
  else,
    indices = c(:);
  endif
  indices=flipud(indices);
  ii=1;
  while ii<=length(indices),
    [trash,idx] = sort( m(:,indices(ii)) ); # sort keeps the original order :)
    m = m( idx,: );
    ii++;
  endwhile
  s = flipud(m);

endfunction



