## usage: [mean, stdev] = threepest [pessemistic, most likeley, optimistic]
##
## Gives a "rough estimate" of the mean and standard deviation of expected
## outcomes based on pessemistic (worst case), most likely, and optimistic
## guesses.  CAREFUL!  while useful, this is only an estimate.  Furthermore
## it only works if the outcomes follow something like the standard 
## distribution.

## This is based on a lecture example by Dr. Alfred Wallace, PE from the 
## University of Idaho

## Author: Kevin Straight stra9456@uidaho.edu

function [mean, stddev]=threepest (wc,ml,bc)

     if(nargin != 3)
        usage("[mean, stddev] = threepest (worst case, most likely, best case)");
     endif

     mean=(bc+4*ml+wc)/6;
     stddev=(bc-wc)/6;

endfunction
